Magisk/scripts/avd_test.sh

192 lines
3.8 KiB
Bash
Raw Normal View History

2022-03-18 11:56:19 +00:00
#!/usr/bin/env bash
emu="$ANDROID_SDK_ROOT/emulator/emulator"
2022-04-16 14:21:02 +00:00
avd="$ANDROID_SDK_ROOT/cmdline-tools/latest/bin/avdmanager"
sdk="$ANDROID_SDK_ROOT/cmdline-tools/latest/bin/sdkmanager"
emu_args='-no-window -gpu swiftshader_indirect -read-only -no-snapshot -no-audio -no-boot-anim -show-kernel'
2023-10-14 06:29:08 +00:00
boot_timeout=600
2023-10-12 05:42:45 +00:00
emu_pid=
2022-03-18 11:56:19 +00:00
# Should be either 'google_apis' or 'default'
type='default'
2022-09-16 02:45:58 +00:00
# We test these API levels for the following reason
# API 23: legacy rootfs w/o Treble
# API 26: legacy rootfs with Treble
# API 28: legacy system-as-root
# API 29: 2 Stage Init
2023-06-08 05:42:31 +00:00
# API 34: latest Android
2022-09-16 02:45:58 +00:00
2023-06-08 05:42:31 +00:00
api_list='23 26 28 29 34'
2022-09-16 02:45:58 +00:00
print_title() {
echo -e "\n\033[44;39m${1}\033[0m\n"
}
print_error() {
echo -e "\n\033[41;39m${1}\033[0m\n"
}
2022-09-16 02:45:58 +00:00
cleanup() {
print_error "! An error occurred when testing $pkg"
2022-09-16 02:45:58 +00:00
for api in $api_list; do
set_api_env $api
restore_avd
done
"$avd" delete avd -n test
2023-05-10 06:11:11 +00:00
pkill -INT -P $$
wait
2023-10-12 05:42:45 +00:00
trap - EXIT
exit 1
}
wait_for_bootanim() {
adb wait-for-device
while true; do
local result="$(adb exec-out getprop init.svc.bootanim)"
if [ $? -ne 0 ]; then
exit 1
elif [ "$result" = "stopped" ]; then
break
fi
sleep 2
done
2022-09-16 02:45:58 +00:00
}
2022-03-18 11:56:19 +00:00
wait_for_boot() {
2023-05-10 06:11:11 +00:00
adb wait-for-device
2022-03-18 11:56:19 +00:00
while true; do
2023-10-12 05:42:45 +00:00
local result="$(adb exec-out getprop sys.boot_completed)"
if [ $? -ne 0 ]; then
exit 1
elif [ "$result" = "1" ]; then
2022-03-18 11:56:19 +00:00
break
fi
sleep 2
done
}
2022-09-16 02:45:58 +00:00
set_api_env() {
pkg="system-images;android-$1;$type;$arch"
2022-09-16 02:45:58 +00:00
local img_dir="$ANDROID_SDK_ROOT/system-images/android-$1/$type/$arch"
2022-04-16 14:21:02 +00:00
ramdisk="$img_dir/ramdisk.img"
features="$img_dir/advancedFeatures.ini"
2022-09-16 02:45:58 +00:00
}
restore_avd() {
2022-03-18 11:56:19 +00:00
if [ -f "${ramdisk}.bak" ]; then
cp "${ramdisk}.bak" "$ramdisk"
fi
2022-04-16 14:21:02 +00:00
if [ -f "${features}.bak" ]; then
cp "${features}.bak" "$features"
fi
2022-09-16 02:45:58 +00:00
}
wait_emu() {
local wait_fn=$1
local which_pid
timeout $boot_timeout bash -c $wait_fn &
local wait_pid=$!
# Handle the case when emulator dies earlier than wait
wait -p which_pid -n $emu_pid $wait_pid
[ $which_pid -eq $wait_pid ]
}
2023-10-12 05:42:45 +00:00
test_emu() {
local variant=$1
print_title "* Testing $pkg ($variant)"
2023-10-12 05:42:45 +00:00
"$emu" @test $emu_args &
emu_pid=$!
wait_emu wait_for_boot
2023-10-12 05:42:45 +00:00
adb shell magisk -v
# Install the Magisk app
adb install -r -g out/app-${variant}.apk
adb shell appops set com.topjohnwu.magisk REQUEST_INSTALL_PACKAGES allow
# Use the app to run setup and reboot
adb shell echo "'content call --uri content://com.topjohnwu.magisk.provider --method setup'" \| /system/xbin/su \
| tee /dev/fd/2 | grep -q 'result=true'
adb reboot
wait_emu wait_for_boot
# Run app tests
adb shell echo "'content call --uri content://com.topjohnwu.magisk.provider --method test'" \| /system/xbin/su \
| tee /dev/fd/2 | grep -q 'result=true'
adb shell echo "'su -c id'" \| /system/xbin/su 2000 | tee /dev/fd/2 | grep -q 'uid=0'
2023-10-12 05:42:45 +00:00
}
2022-09-16 02:45:58 +00:00
run_test() {
2023-05-10 06:11:11 +00:00
local api=$1
set_api_env $api
2022-09-16 02:45:58 +00:00
# Setup emulator
"$sdk" $pkg
echo no | "$avd" create avd -f -n test -k $pkg
2023-10-12 05:42:45 +00:00
# Launch stock emulator
print_title "* Launching $pkg"
2022-09-16 02:45:58 +00:00
restore_avd
2022-04-16 14:21:02 +00:00
"$emu" @test $emu_args &
2023-10-12 05:42:45 +00:00
emu_pid=$!
wait_emu wait_for_bootanim
2023-04-24 20:54:46 +00:00
2023-10-12 05:42:45 +00:00
# Patch and test debug build
2022-04-16 14:21:02 +00:00
./build.py avd_patch -s "$ramdisk"
2023-10-12 05:42:45 +00:00
kill -INT $emu_pid
wait $emu_pid
test_emu debug
2022-03-18 11:56:19 +00:00
2023-10-12 05:42:45 +00:00
# Re-patch and test release build
2023-10-09 12:47:50 +00:00
./build.py -r avd_patch -s "$ramdisk"
2023-10-12 05:42:45 +00:00
kill -INT $emu_pid
wait $emu_pid
test_emu release
2023-10-09 12:47:50 +00:00
2023-10-12 05:42:45 +00:00
# Cleanup
kill -INT $emu_pid
wait $emu_pid
2022-09-16 02:45:58 +00:00
restore_avd
2022-03-18 11:56:19 +00:00
}
2022-09-16 02:45:58 +00:00
trap cleanup EXIT
2022-03-18 11:56:19 +00:00
2022-09-16 02:45:58 +00:00
export -f wait_for_boot
2023-10-12 05:42:45 +00:00
export -f wait_for_bootanim
2022-09-16 02:45:58 +00:00
set -xe
case $(uname -m) in
'arm64'|'aarch64')
arch=arm64-v8a
;;
*)
arch=x86_64
;;
esac
2023-04-24 20:54:46 +00:00
yes | "$sdk" --licenses
"$sdk" --channel=3 --update
2022-03-18 11:56:19 +00:00
2023-05-10 06:11:11 +00:00
if [ -n "$1" ]; then
run_test $1
else
for api in $api_list; do
run_test $api
done
fi
2022-03-18 11:56:19 +00:00
2022-04-16 14:21:02 +00:00
"$avd" delete avd -n test
2022-03-18 11:56:19 +00:00
trap - EXIT